/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.faces.core.renderer.html;

import java.util.List ;
import java.util.ResourceBundle ;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.UIGrid;
import org.exoplatform.faces.core.component.model.HtmlFragment;

public  class GridRenderer extends HtmlBasicRenderer {

  public void encodeBegin( FacesContext context, UIComponent component ) throws IOException {
  }

  public void encodeChildren( FacesContext context, UIComponent component ) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
    UIGrid uiGrid = (UIGrid) component ; 
    String clazz = uiGrid.getClazz() ;
    w.write("<table") ;
    w.write(" class='UIGrid");
    if(clazz != null)  {
      w.write(' ') ; w.write(clazz) ;
    }
    w.write("'>") ;
    List rows = uiGrid.getRows() ;
    for (int i = 0 ; i < rows.size() ; i++) {
      HtmlFragment row = (HtmlFragment) rows.get(i) ;
      row.render(w, res, uiGrid) ;
    }
    w.write("</table>") ;
  }

  public void encodeEnd( FacesContext context, UIComponent component ) throws IOException {

  }
}