/**
 * Copyright 2001-2004 The eXo Platform SARL         All rights reserved.
 * Please look at license.txt in info directory for more license detail.
 **/
package org.exoplatform.services.organization.ldap;

import netscape.ldap.*;
import java.util.*;

import java.util.Enumeration;

/**
 * Created by the eXo platform team
 * User: Daniel Summer
 * Date: 28 august 2004
 *
 */

public class BaseLDAPHandler {

	protected String getutil(String field, LDAPAttributeSet attrs) {
		if (attrs.getAttribute(field) == null) {
			return new String("");
		} else {
			try {
				return attrs
					.getAttribute(field)
					.getStringValues()
					.nextElement()
					.toString();
			} catch (Exception e) {
				return new String("");
			}
		}
	}

	protected String fastgetutil(String field, LDAPAttributeSet attrs)
		throws Exception {
		LDAPAttribute values = attrs.getAttribute(field);
		if (values == null)
			return new String("");

		Enumeration e = values.getStringValues();
		if (e == null || !e.hasMoreElements())
			return new String("");

		return e.nextElement().toString();
	}

	protected Vector getutil(
		String field,
		LDAPAttributeSet attrs,
		boolean empty) {
		Vector values = null;
		String temp;

		if (empty) {
			values = new Vector();
		}
		values = new Vector();
		try {
			LDAPAttribute attr = attrs.getAttribute(field);
			if (null != attr) {

				for (Enumeration enum = attr.getStringValues();
					enum.hasMoreElements();
					) {
					temp = (String) enum.nextElement();
					values.add(temp);
				}

			}
		} catch (Exception e) {
			//logger.warn( "getUtil(): " + e.getMessage(), e );
		}

		return values;
	}

	protected List getUtil(LDAPSearchResults res) {
		List l = new ArrayList();
		while (res.hasMoreElements()) {

			LDAPEntry findEntry = null;
			try {
				findEntry = res.next();
				l.add(findEntry);

			} catch (LDAPException e) {
				continue;
			}
		}
		return l;
	}

	/*
		protected void setutil(
			String field,
			Object value,
			LDAPAttributeSet attrs) {
			attrs.remove(field);
			attrs.add(new LDAPAttribute( field, value  ));
			updated = true;
		}
	*/
	protected void setutil(
		String field,
		String value,
		LDAPAttributeSet attrs) {
		attrs.remove(field);
		if (value == null || value.length() == 0)
			value = " ";
		attrs.add(new LDAPAttribute(field, value));

	}

	protected void setutil(
		String field,
		Vector values,
		LDAPAttributeSet attrs) {
		setutil(field, values, attrs, false);
	}

	protected void setutil(
		String field,
		Vector values,
		LDAPAttributeSet attrs,
		boolean create) {
		attrs.remove(field);

		if (values == null || (values.size() == 0 && create)) {
			return;
		}

		LDAPAttribute attr =
			new LDAPAttribute(field, (String[]) values.toArray());
		attrs.add(attr);

	}

	protected void setutil(
		String field,
		String[] values,
		LDAPAttributeSet attrs,
		boolean create) {
		attrs.remove(field);

		if (values == null || (values.length == 0 && create)) {
			return;
		}

		LDAPAttribute attr = new LDAPAttribute(field, values);
		attrs.add(attr);

	}
}