/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.portal ;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.condition.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.ExpectFormNameValidator;
import org.exoplatform.test.web.validator.ExpectLinkWithTextValidator;

/**
 * May 21, 2004
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: PortletRegistrySuite.java,v 1.1 2004/10/11 23:27:29 tuan08 Exp $
 **/
public class PortletRegistrySuite extends WebUnitSuite {

  public PortletRegistrySuite(String path) {
    super("PortletRegistrySuite", "Go to the portlet registry page and do some basic actions") ;
    goToPage(path) ;
    addWebUnit(
      new ClickLink("EmtypDatabase", "Remove all the categories").
      setTextLink("Remove All").setBlockId("page")
    ) ;
    addWebUnit(
      new ClickLinkWithText("CreateNewCategory", "Create a new portlet category").
      setTextLink("Create New Category").
	  addValidator(new ExpectFormNameValidator("portletCategoryForm"))
	) ; 
    addWebUnit(
      new SubmitFormUnit("SubmitCategroryForm", "Fill the portlet category and submit").
      setFormName("portletCategoryForm").
      setField(name:"new category", description:"For any users",op:"save").
      addValidator(new ExpectLinkWithTextValidator("new category"))
    ) ;
    addWebUnit(
      new ClickLinkWithText("ClickNewCategory", "Click on the new created category").
      setTextLink("new category")
    ) ;
    addWebUnit(
      new ClickLinkWithText("ClickAddPortlet", "add portlet for the new created category").
      setTextLink("Add Portlet").
	  addValidator(new ExpectFormNameValidator("portletForm"))
	) ;
    addWebUnit(
      new SubmitFormUnit("AddPortlets", "Add portlets").
      setFormName("portletForm").
      setField(portletId:"content/DisplayContent", op:"save").
      addValidator(new ExpectLinkWithTextValidator("DisplayContent"))
    ) ;
    addWebUnit(
      new ClickLinkWithText("ClickDisplayContent", "Click on DisplayContent Portlet").
      setTextLink("DisplayContent")
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("EditDisplayContent", "Click on Edit Link").
      setURL("UIPortletInfo&op=editPortlet").
	  addValidator(new ExpectFormNameValidator("portletForm"))
	) ;
    addWebUnit(
   	  new SubmitFormUnit("UpdatePortletInfo", "Fill the portlet form  and submit").
      setFormName("portletForm").
      setField(name:"DisplatContentPortlet(update)", description:"description (update)").
      setField("op","save").
      addValidator(new ExpectLinkWithTextValidator("DisplatContentPortlet(update)"))
    ) ;
    addWebUnit(
      new ClickLink("ClickNewCategory", "Click on the new created category").
      setTextLink("new category")
    ) ;
    addWebUnit(
      new ClickLinkWithText("DeleteCategory", "Delete the old category if present").
      setTextLink("Delete Category").
      addCondition(new HaveLinkWithTextCondition("Delete Category"))
    ) ;
    addWebUnit(
      new ClickLink("ImportCatgories", "Import the available portlets from the portlet container").
      setTextLink("Import Portlets")
    ) ;
    // set portlet roles
    addWebUnit(
      new ClickLink("ClickWSRPCategory", "Click on the wsrp link in the menu").
      setTextLink("wsrp").
	  setBlockId("page")
	) ;
    addWebUnit(
      new ClickLink("ClickWSRPAdminPortlet", "Click on the wsrp admin portlet in the menu").
      setTextLink("WSRPAdminPortlet").
      setBlockId("page")
    ) ;
    addWebUnit(
      new ClickLink("ClickAddRolePortlet", "Click on the add role link").
      setTextLink("Add Role to Portlet").
      setBlockId("page")
    ) ;
    
    addWebUnit(
      new SubmitFormUnit("RemoveUserRole", "Remove the user role").
      setFormName("portletRoleForm").
      setField("currentRoleSelect", "user").
      setField("op","removeRole")
    ) ;
    
    addWebUnit(
      new SubmitFormUnit("AddAdminRole", "Add the admin role for the portlet").
      setFormName("portletRoleForm").
      setField("availableRolesSelect", "admin").
      setField("op","addRole")
    ) ;
    addWebUnit(
      new SubmitFormUnit("SaveRoles", "Save the roles for the portlet").
      setFormName("portletRoleForm").
      setField("op","save")
    ) ;
  }
}